/*
 * Copyright (C) 2005 Bernhard Erb

 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.

 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.

 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


/************************************************************
 * project=tweety                                           *
 * codename=kleiner eibnet/ip server                        *
 * version=1.1                                              *
 ************************************************************/

/**
 * @file common.c
 *
 * This file contains the code for basic methods.
 *
 * @date created 16.05.05,
 *       last modified 02.09.05
 *
 * @author bernhard erb
 *         bernhard.erb@gmx.net
 *
 */ 

/*
 * ********************************************* includes ***
 */

#include "common.h"

/*
 * ******************************************* prototypes ***
 */
void *freeResources();		/* forward declaration: method in server.c */


/*
 * ******************************************** functions ***
 */


/**
 * This method is called in case of 
 * erroneous programm execution. It
 * terminates the server and prints
 * out the passed error message in
 * combination with the system error
 * message
 */
void bailOut(char *message)
{				/* error function */
    fprintf(stdout, "*** bail out *** \n");
    fprintf(stdout, "%s \n", message);
    fprintf(stdout, "Error: %s \n", strerror(errno));
    freeResources();
    exit(-1);
}

/**
 * Utility method for showing the
 * packet content in byte format
 */
void zeig(byte * _Packet, int length)
{				/* utility for showing packets */
  byte *bl = (byte *) _Packet;
  int i;
  fflush(stdout);
  for (i = 1; i < length + 1; i++) {
    fprintf(stdout, "%X ", *bl);
    bl++;
  }
  fprintf(stdout, "\n");
}

/**
 * Sends the passed packet to
 * the given address
 */
void sendPacket(EIBNETIP_PACKET * packet, struct sockaddr_in address)
{
    if (sendto(sock,
	       packet,
	       htons(packet->head.totalsize),
	       0, (struct sockaddr *) &address,
	       sizeof(struct sockaddr_in)) < 0) {
	bailOut("Error: can't sent UDP packet");
    }
}


/*
 * ************************************************** EOF ***
 */
