/*
 * Copyright (C) 2005 Bernhard Erb

 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.

 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.

 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/************************************************************
 * project=tweety                                           *
 * codename=kleiner eibnet/ip server                        *
 * version=1.1                                              *
 ************************************************************/

/**
 * @file common.h
 *
 * This file contains projects local definitions.
 *
 * @date created 16.05.05,
 *       last modified 02.09.05
 *
 * @author bernhard erb
 *         bernhard.erb@gmx.net
 *
 */ 


/*
 * ********************************************* includes ***
 */

#include <stdlib.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <limits.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>
#include <pthread.h>
#include <signal.h>
#include <sys/un.h>
#include <sys/stat.h>
#include <sys/shm.h>
#include <fcntl.h>
#include <semaphore.h>
#include <sys/wait.h>
#include "eibnetip.h"
#include "cemi.h"

/*
 * ************************************************** defines ***
 */

#define SERVERPORT 3671
#define SERVERADDRESS "128.130.60.107"
#define MULTICASTADDRESS "224.0.23.12"
#define STANDARDDEVICE "/dev/eib"
/*#define DEBUG*/
/*#define SECURE*/

#define SEND_PIPE "/tmp/sendpipen"
#define RECEIVE_PIPE "/tmp/receivepipein"
#define PERM 0666

#define KEY_SEMAPHOR "sem"
#define KEY_SMEMORY 0x4781

/*
 * ********************************************* typedefinitions ***
 */


typedef struct {
    byte reset;
    byte channelid;
    byte sequenceSend;
    byte sequenceReceive;
    time_t lastaccess;
    struct sockaddr_in control_endpoint;
    struct sockaddr_in data_endpoint;
} connection;


/*
 * ****************************************** global variables ***
 */

int serverport;			/* the serverport */
int sock;			/* the serversocket */
struct sockaddr_in serverAddr;	/* the severaddress */
int eib_fd;			/* eib filedescriptor */
const char *szCommand;		/* commandname */
char *device;			/* deivce name */
char *friendlyName;		/* friendly Name */

sem_t *semid;			/* semaphore pointer */
int nSharedMem;
connection *active_connection;
word address;			/* the knx address of the bcu */
byte tablesize;			/* the initial tablesize */

pid_t pid_SendUdp;		/* processnumber of send upd */
pid_t pid_ReceiveUdp;		/* processnumber of receive udp */

pthread_t thread_receive_eib, thread_send_eib;
int iret_receive_eib, iret_send_eib;



void bailOut(char *message);	/* forward declaration: method in header.c */
void zeig(byte * message, int length); /* forward declaration: method in header.h*/

/*
 * ********************************************************* EOF ***
 */
